Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CaptureOne.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CaptureOne.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CaptureOne.pm	(revision 34921)
@@ -18,5 +18,5 @@
 use Image::ExifTool::ZIP;
 
-$VERSION = '1.02';
+$VERSION = '1.04';
 
 # CaptureOne COS XML tags
@@ -34,7 +34,9 @@
 # Inputs: 0) attribute list ref, 1) attr hash ref,
 #         2) property name ref, 3) property value ref
+# Returns: true if value was changed
 sub HandleCOSAttrs($$$$)
 {
     my ($attrList, $attrs, $prop, $valPt) = @_;
+    my $changed;
     if (not length $$valPt and defined $$attrs{K} and defined $$attrs{V}) {
         $$prop = $$attrs{K};
@@ -51,5 +53,7 @@
             }
         }
-    }
+        $changed = 1;
+    }
+    return $changed;
 }
 
@@ -62,9 +66,9 @@
 sub FoundCOS($$$$;$)
 {
-    my ($exifTool, $tagTablePtr, $props, $val, $attrs) = @_;
+    my ($et, $tagTablePtr, $props, $val, $attrs) = @_;
 
     my $tag = $$props[-1];
     unless ($$tagTablePtr{$tag}) {
-        $exifTool->VPrint(0, "  | [adding $tag]\n");
+        $et->VPrint(0, "  | [adding $tag]\n");
         my $name = ucfirst $tag;
         $name =~ tr/-_a-zA-Z0-9//dc;
@@ -78,11 +82,11 @@
             $tagInfo{PrintConv} = '$self->ConvertDateTime($val)';
         }
-        Image::ExifTool::AddTagToTable($tagTablePtr, $tag, \%tagInfo);
+        AddTagToTable($tagTablePtr, $tag, \%tagInfo);
     }
     # convert from UTF8 to ExifTool Charset
-    $val = $exifTool->Decode($val, "UTF8");
+    $val = $et->Decode($val, "UTF8");
     # un-escape XML character entities
     $val = Image::ExifTool::XMP::UnescapeXML($val);
-    $exifTool->HandleTag($tagTablePtr, $tag, $val);
+    $et->HandleTag($tagTablePtr, $tag, $val);
     return 0;
 }
@@ -94,5 +98,5 @@
 sub ProcessCOS($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
 
     # process using XMP module, but override handling of attributes and tags
@@ -102,5 +106,5 @@
     };
     my $tagTablePtr = GetTagTable('Image::ExifTool::CaptureOne::Main');
-    my $success = $exifTool->ProcessDirectory($dirInfo, $tagTablePtr);
+    my $success = $et->ProcessDirectory($dirInfo, $tagTablePtr);
     delete $$dirInfo{XMLParseArgs};
     return $success;
@@ -116,9 +120,9 @@
 sub ProcessEIP($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $zip = $$dirInfo{ZIP};
     my ($file, $buff, $status, $member, %parseFile);
 
-    $exifTool->SetFileType('EIP');
+    $et->SetFileType('EIP');
 
     # must catch all Archive::Zip warnings
@@ -156,8 +160,8 @@
         $file = $member->fileName();
         next unless defined $file;
-        $exifTool->VPrint(0, "File: $file\n");
+        $et->VPrint(0, "File: $file\n");
         # set the document number and extract ZIP tags
-        $$exifTool{DOC_NUM} = ++$docNum;
-        Image::ExifTool::ZIP::HandleMember($exifTool, $member);
+        $$et{DOC_NUM} = ++$docNum;
+        Image::ExifTool::ZIP::HandleMember($et, $member);
         if (%parseFile) {
             next unless $parseFile{$file};
@@ -170,5 +174,5 @@
         # Note: this could use a LOT of memory here for RAW images...
         ($buff, $status) = $zip->contents($member);
-        $status and $exifTool->Warn("Error extracting $file"), next;
+        $status and $et->Warn("Error extracting $file"), next;
         if ($file =~ /\.cos$/i) {
             # process Capture One Settings files
@@ -178,16 +182,16 @@
                 DataLen => length $buff,
             );
-            ProcessCOS($exifTool, \%dirInfo);
+            ProcessCOS($et, \%dirInfo);
         } else {
             # set HtmlDump error if necessary because it doesn't work with embedded files
-            if ($$exifTool{HTML_DUMP}) {
-                $$exifTool{HTML_DUMP}{Error} = "Sorry, can't dump images embedded in ZIP files";
+            if ($$et{HTML_DUMP}) {
+                $$et{HTML_DUMP}{Error} = "Sorry, can't dump images embedded in ZIP files";
             }
             # process IIQ, JPEG and TIFF images
-            $exifTool->ExtractInfo(\$buff, { ReEntry => 1 });
+            $et->ExtractInfo(\$buff, { ReEntry => 1 });
         }
         undef $buff;    # (free memory now)
     }
-    delete $$exifTool{DOC_NUM};
+    delete $$et{DOC_NUM};
     return 1;
 }
@@ -218,5 +222,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Casio.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Casio.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Casio.pm	(revision 34921)
@@ -10,6 +10,7 @@
 #               2) Joachim Loehr private communication
 #               3) http://homepage3.nifty.com/kamisaka/makernote/makernote_casio.htm
-#               4) http://www.gvsoft.homedns.org/exif/makernote-casio.html
+#               4) http://gvsoft.homedns.org/exif/makernote-casio-type1.html
 #               5) Robert Chi private communication (EX-F1)
+#               6) https://exiftool.org/forum/index.php/topic,3701.html
 #               JD) Jens Duttke private communication
 #------------------------------------------------------------------------------
@@ -21,5 +22,5 @@
 use Image::ExifTool::Exif;
 
-$VERSION = '1.32';
+$VERSION = '1.38';
 
 # older Casio maker notes (ref 1)
@@ -236,7 +237,7 @@
             5 => 'Far Left/Right of Center',
             6 => 'Far Left/Right of Center/Bottom',
-            7 => 'Top Near-Left',
+            7 => 'Top Near-left',
             8 => 'Near Upper/Left',
-            9 => 'Top Near-Right',
+            9 => 'Top Near-right',
             10 => 'Top Left',
             11 => 'Top Center',
@@ -291,4 +292,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -300,4 +302,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -401,4 +404,5 @@
         # (nasty that they double-reference the image!)
         %Image::ExifTool::previewImageTagInfo,
+        Groups => { 2 => 'Preview' },
     },
     0x2001 => { #PH
@@ -442,4 +446,5 @@
            0 => 'Manual',
            1 => 'Daylight', #3
+           2 => 'Cloudy', #PH (EX-ZR20, NC)
            3 => 'Shade', #3
            4 => 'Flash?',
@@ -487,4 +492,5 @@
             # have also seen '1 1 1', '2 2 4', '4 3 3', '4 4 4'
             # '0 0 14' and '0 0 42' - premium auto night shot (EX-Z2300)
+            # and '0 0 2' for Art HDR
         },
     },
